using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace jRuleAlgorithm
{
    class jRuleAlgorithm
    {
        static void Main(string[] args)
        {
            try
            {
                if (args.Length < 0)
                {
                    Console.WriteLine("Usage: jRuleAlgorithm.exe ../dxi/Car.dxi 0 time");
                }
                else
                {
                    Stopwatch stopwatch = new Stopwatch();
                    Console.WriteLine("Complex rules from jRule algorithm");
                    DEXi.Model model = new DEXi.Model(args[0]);
                    List<DEXi.Attribute> all = model.AllAttributes;
                    int position = Convert.ToInt32(args[1]);
                    DEXi.jRule jr = new DEXi.jRule(all[position]);
                    if(args.Length > 2)
                    {
                        if (args[2].Equals("time"))
                        {
                            stopwatch.Start();
                            jr.ComplexRules();
                            stopwatch.Stop();
                            Console.WriteLine("Time elapsed: {0} ms", stopwatch.ElapsedMilliseconds);
                        }
                    }
                    else
                    {
                        jr.ComplexRules();
                    }
                    Console.WriteLine("=========================================================");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("jRuleAlgorithm: Exception: " + e.Message);
            }
        }
    }
}
